package analyzer;

import java.util.Iterator;
import java.util.List;

import pt.uc.dei.wsdbench.sut.domain.schema.Main;
import pt.uc.dei.wsdbench.sut.domain.schema.helper.Helper;
import pt.uc.dei.wsdbench.sut.domain.schema.type.ComplexType;
import pt.uc.dei.wsdbench.sut.injector.result.PendingResult;


public class Cleaner
{
    public static void removeNoFaultRequests(List<PendingResult> pendingResultList)
    {
	Iterator<PendingResult> iter = pendingResultList.iterator();
	while (iter.hasNext())
	{
	    PendingResult pendingResult = (PendingResult) iter.next();

	    if (pendingResult.getFaultLocation() == null)
	    {
		iter.remove();
	    }
	}
    }

    
    public static void removeValidDomainOutputs(List<PendingResult> pendingResultList)
    {
	//ComplexType outputDeclaration = Main.loadComplexType("ChangePaymentMethodOutputDeclaration.xsd");
	//ComplexType outputDefinition = Main.loadComplexType("ChangePaymentMethodOutputDefinition.xsd");
	ComplexType outputDeclaration = Main.loadComplexType(Initializer.OUT_DEC);
	ComplexType outputDefinition = Main.loadComplexType(Initializer.OUT_DEF);	
	Main.flatStructure = Helper.buildFlatStructureMap(outputDefinition);
	
	Iterator<PendingResult> iter = pendingResultList.iterator();
	while (iter.hasNext())
	{
	    PendingResult pendingResult = (PendingResult) iter.next();

	    if (pendingResult.getOutput() instanceof Exception)
	    {
		continue;
	    }
	    
	    boolean valid = Helper.validateArguments(new Object[]{pendingResult.getOutput()}, outputDeclaration, outputDefinition);
	    
	    if (valid)
	    {
		iter.remove();
	    }
	}
    }
}
