package pt.uc.dei.wsdbench.sut.dao.tpcapp;

import java.sql.SQLException;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.jdbc.core.namedparam.SqlParameterSource;
import org.springframework.jdbc.core.support.JdbcDaoSupport;

import pt.uc.dei.wsdbench.sut.service.input.ChangePaymentMethodInput;

public class ChangePaymentMethodDao extends JdbcDaoSupport
{
    private NamedParameterJdbcTemplate namedParameterJdbcTemplate;

    private Log log = LogFactory.getLog(ChangePaymentMethodDao.class);

    public String findBusinessNameById(long customerId) throws SQLException
    {
	String result = null;
	final String sql = "SELECT C_BUSINESS_NAME FROM CUSTOMER" + " WHERE C_ID = ?";
	Long[] args =
	{ customerId };

	try
	{
	    result = (String) this.getJdbcTemplate().queryForObject(sql, args, String.class);
	} catch (Exception e)
	{
	    log.error(e);
	}

	return result;
    }

    public void update(ChangePaymentMethodInput changePaymentMethodInput) throws SQLException
    {
	String sql = "UPDATE CUSTOMER" + " SET C_PAYMENT_METHOD = :paymentMethod," + " C_CREDIT_INFO = :creditInfo,"
		+ " C_PO= :poId" + " WHERE C_ID = :customerId";

	SqlParameterSource paramSource = new BeanPropertySqlParameterSource(changePaymentMethodInput);

	this.namedParameterJdbcTemplate.update(sql, paramSource);
    }
    
    public void setNamedParameterJdbcTemplate(NamedParameterJdbcTemplate namedParameterJdbcTemplate)
    {
	this.namedParameterJdbcTemplate = namedParameterJdbcTemplate;
    }

}
