package pt.uc.dei.wsdbench.sut.dao.tpcapp;

import java.sql.Date;
import java.sql.SQLException;
import java.util.Calendar;
import java.util.List;

import org.springframework.jdbc.core.simple.SimpleJdbcTemplate;

import pt.uc.dei.wsdbench.sut.dao.rowmapper.NewProductRowmapper;
import pt.uc.dei.wsdbench.sut.service.input.NewProductsInput;
import pt.uc.dei.wsdbench.sut.service.output.NewProduct;

public class NewProductsDao
{
    private SimpleJdbcTemplate simpleJdbcTemplate;

    private final static int MINUTES_TO_MILLIS = 60 * 1000;

    private Date subtractMinutesToCurrentDate(Long minutes)
    {
	long millis = (Calendar.getInstance().getTimeInMillis() - minutes.longValue() * MINUTES_TO_MILLIS);

	final Date result = new Date(millis);

	return result;
    }

    // TODO create delegates for other dbms
    public List<NewProduct> findNewProducts(NewProductsInput newProductsInput) throws SQLException
    {
	List<NewProduct> result;
	Date toCompare = subtractMinutesToCurrentDate(newProductsInput.getCutOffDuration());

	String sql = "SELECT I_ID, I_TITLE, A_FNAME, A_LNAME" + " FROM ITEM I, AUTHOR A" + " WHERE I.I_A_ID = A.A_ID"
		+ " AND I.I_SUBJECT LIKE ?" + " AND I.I_PUB_DATE > ?";
	final Object[] args =
	{ newProductsInput.getSubjectString(), toCompare };

	result = this.simpleJdbcTemplate.query(sql, new NewProductRowmapper(), args);

	return result;
    }

    public void setSimpleJdbcTemplate(SimpleJdbcTemplate simpleJdbcTemplate)
    {
	this.simpleJdbcTemplate = simpleJdbcTemplate;
    }
}
