package pt.uc.dei.wsdbench.sut.dbms.core;

import org.springframework.jdbc.core.support.JdbcDaoSupport;

public class SequenceHolder extends JdbcDaoSupport
{
    private Long address;

    private Long author;

    private Long country;

    private Long customer;

    private Long orderline;

    private Long orders;

    private Long item;

    private Long stock;

    public SequenceHolder()
    {
	// empty
    }

    /**
     * Load current sequence values from database.
     * 
     */
    public void init()
    {

	String sql;

	sql = "SELECT MAX(ADDR_ID) FROM ADDRESS";
	this.address = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(A_ID) FROM AUTHOR";
	this.author = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(CO_ID) FROM COUNTRY";
	this.country = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(C_ID) FROM CUSTOMER";
	this.customer = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(I_ID) FROM ITEM";
	this.item = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(O_ID) FROM ORDERS";
	this.orders = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(OL_ID) FROM ORDER_LINE";
	this.orderline = this.getJdbcTemplate().queryForLong(sql);

	sql = "SELECT MAX(S_I_ID) FROM STOCK";
	this.stock = this.getJdbcTemplate().queryForLong(sql);

    }

    public synchronized Long nextAddress()
    {
	return ++this.address;
    }

    public synchronized Long nextAuthor()
    {
	return ++this.author;
    }

    public synchronized Long nextCountry()
    {
	return ++this.country;
    }

    public synchronized Long nextCustomer()
    {
	return ++this.customer;
    }

    public synchronized Long nextOrderline()
    {
	return ++this.orderline;
    }

    public synchronized Long nextOrders()
    {
	return ++this.orders;
    }

    public synchronized Long nextItem()
    {
	return ++this.item;
    }

    public Long nextStock()
    {
	return ++this.stock;
    }

}
