package pt.uc.dei.wsdbench.sut.domain.schema;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.Map;

import pt.uc.dei.wsdbench.sut.domain.schema.helper.ComplexTypeAndElementAndRestriction;
import pt.uc.dei.wsdbench.sut.domain.schema.type.ComplexType;

import com.thoughtworks.xstream.XStream;


public class Main
{
    public static Map<String, ComplexTypeAndElementAndRestriction> flatStructure;

    private static String loadXml(String fileName) throws URISyntaxException, FileNotFoundException
    {
	String result = "";

	File file = new File(fileName);
	FileReader fileReader = new FileReader(file);
	BufferedReader reader = new BufferedReader(fileReader);
	try
	{
	    while (true)
	    {
		String tmp = reader.readLine();
		if (tmp == null)
		{
		    break;
		}
		result += tmp;
	    }
	}
	catch (IOException e)
	{
	    e.printStackTrace();
	}

	return result;
    }

    ComplexType[] array = new ComplexType[10];

    public static ComplexType loadComplexType(String fileName)
    {
	ComplexType result = null;

	try
	{
	    XStream xstream = new XStream();
	    xstream.autodetectAnnotations(true);
	    xstream.alias("xs:complexType", ComplexType.class);

	    result = (ComplexType) xstream.fromXML(Main.loadXml(fileName));
	}
	catch (FileNotFoundException e)
	{
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	catch (URISyntaxException e)
	{
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}

	return result;
    }

    public static void printXml(ComplexType complexType)
    {
	XStream xstream = new XStream();
	xstream.autodetectAnnotations(true);
	xstream.alias("xs:complexType", ComplexType.class);

	System.out.println(xstream.toXML(complexType));
    }

//    public static void main(String[] args) throws URISyntaxException, FileNotFoundException
//    {
//
//	ComplexType complexTypeDeclaration = loadComplexType("ComplexTypeDeclaration.xml");
//	printXml(complexTypeDeclaration);
//
//	System.out.println("---------------------------------");
//
//	ComplexType complexTypeDefinition = loadComplexType("ComplexTypeDefinition.xml");
//	printXml(complexTypeDefinition);
//
//	Main.flatStructure = Helper.buildFlatStructureMap(complexTypeDefinition);
//
//	MyInput input1 = new MyInput();
//	input1.setContent("121");
//	input1.setValue1(122L);
//	input1.setValue2(121L);
//
//	MyInput input2 = new MyInput();
//	input2.setContent("150");
//	input2.setValue1(150L);
//	input2.setValue2(150L);
//
//	Object[] arguments = new Object[]
//	{ input1, input2 };
//
//	Helper.validateArguments(arguments, complexTypeDeclaration, complexTypeDefinition);
//
//	/*
//	 * Restriction restriction = new Restriction();
//	 * 
//	 * System.out.println(xstream.toXML(restriction));
//	 * System.out.println("---------------------------");
//	 * 
//	 * Restriction r = (Restriction) xstream.fromXML(xml);
//	 * System.out.println(xstream.toXML(r));
//	 */
//    }
}
