package pt.uc.dei.wsdbench.sut.domain.schema.helper;

import java.util.List;
import java.util.regex.Pattern;

import pt.uc.dei.wsdbench.sut.domain.schema.base.Enumeration;
import pt.uc.dei.wsdbench.sut.domain.schema.restriction.Restriction;

public class FunctionHelper
{

    public static boolean fitsRestriction(Restriction restriction, Object argument)
    {
	boolean result = false;

	if (restriction.getPattern() != null)
	{
	    result = Pattern.matches(restriction.getPattern().getValue(), String.valueOf(argument));
	    
	    //TODO uncomment
	 //   System.out.println("result = " + result + " for argument " + String.valueOf(argument) + " and pattern:"
	//	    + restriction.getPattern().getValue());
	}
	else if (restriction.getEnumerationList() != null)
	{
	    for (Enumeration item : restriction.getEnumerationList())
	    {
		if (argument != null && argument.equals(item.getValue()))
		{
		    result = true;
		    break;
		}
	    }
	}
	else if ((restriction.getMinExclusive() != null) && (restriction.getMaxExclusive() != null))
	{
	    if (argument == null)
	    {
		result = false;
	    }
	    if (argument instanceof List)
	    {
		Long val = new Long(((List) argument).size());
		result = ((val > restriction.getMinExclusive().getValue()) && (val < restriction.getMaxExclusive()
			.getValue()));
	    }	    
	    else
	    {
		Long val = (Long) argument;
		result = ((val > restriction.getMinExclusive().getValue()) && (val < restriction.getMaxExclusive()
			.getValue()));
	    }
	}
	if (restriction.getMaxLength() != null && restriction.getMinLength() != null)
	{
	    String tmp = String.valueOf(argument);
	    if (restriction.getPattern() == null)
	    {
		result = (((tmp.length() >= restriction.getMinLength().getValue()) && (tmp.length() <= restriction
			.getMaxLength().getValue())));
	    }
	    else
	    {
		result = (result && ((tmp.length() >= restriction.getMinLength().getValue()) && (tmp.length() <= restriction
			.getMaxLength().getValue())));
	    }

	}
	// UNCoMMENT QD ESTIVER CORRIGIDO else
	// {
	// System.out.println("All applicable restrictions were null. Should never happen!");
	// }

	if (result)
	{
	   // System.out.println("Argument (" + argument + ") fits restriction: " + Tools.describeObject(restriction));
	}

	return result;
    }
}
