package pt.uc.dei.wsdbench.sut.domain.schema.restriction;

import java.util.ArrayList;
import java.util.List;

import pt.uc.dei.wsdbench.sut.domain.schema.base.Enumeration;
import pt.uc.dei.wsdbench.sut.domain.schema.base.LongValueWrapper;
import pt.uc.dei.wsdbench.sut.domain.schema.base.StringValueWrapper;


import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import com.thoughtworks.xstream.annotations.XStreamImplicit;


@XStreamAlias("xs:restriction")
public class Restriction
{
    @XStreamAsAttribute
    private String id = "r5";

    @XStreamAsAttribute
    private Boolean isDefault = true;

    @XStreamAlias("xs:minExclusive")
    private LongValueWrapper minExclusive = new LongValueWrapper();

    @XStreamAlias("xs:maxExclusive")
    private LongValueWrapper maxExclusive = new LongValueWrapper();

    @XStreamAlias("xs:minLength")
    private LongValueWrapper minLength = new LongValueWrapper();

    @XStreamAlias("xs:maxLength")
    private LongValueWrapper maxLength = new LongValueWrapper();

    @XStreamAlias("xs:pattern")
    private StringValueWrapper pattern = new StringValueWrapper();

    @XStreamImplicit
    private List<Enumeration> enumerationList = new ArrayList<Enumeration>();

    public Restriction()
    {
	Enumeration w = new Enumeration("5");
	Enumeration x = new Enumeration("7");
	enumerationList.add(w);
	enumerationList.add(x);
    }

    public String getId()
    {
	return id;
    }

    public void setId(String id)
    {
	this.id = id;
    }

    public Boolean getIsDefault()
    {
	return isDefault;
    }

    public void setIsDefault(Boolean isDefault)
    {
	this.isDefault = isDefault;
    }

    public LongValueWrapper getMinExclusive()
    {
	return minExclusive;
    }

    public void setMinExclusive(LongValueWrapper minExclusive)
    {
	this.minExclusive = minExclusive;
    }

    public LongValueWrapper getMaxExclusive()
    {
	return maxExclusive;
    }

    public void setMaxExclusive(LongValueWrapper maxExclusive)
    {
	this.maxExclusive = maxExclusive;
    }

    public LongValueWrapper getMinLength()
    {
	return minLength;
    }

    public void setMinLength(LongValueWrapper minLength)
    {
	this.minLength = minLength;
    }

    public LongValueWrapper getMaxLength()
    {
	return maxLength;
    }

    public void setMaxLength(LongValueWrapper maxLength)
    {
	this.maxLength = maxLength;
    }

    public StringValueWrapper getPattern()
    {
	return pattern;
    }

    public void setPattern(StringValueWrapper pattern)
    {
	this.pattern = pattern;
    }

    public List<Enumeration> getEnumerationList()
    {
	return enumerationList;
    }

    public void setEnumerationList(List<Enumeration> enumerationList)
    {
	this.enumerationList = enumerationList;
    }

}