package pt.uc.dei.wsdbench.sut.injector;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Fault
{
    public static enum Type
    {
	string, number, list
    };

    public static final String NUMBER_NULL = "numberNull";
    public static final String NUMBER_ABSOLUTE_ZERO = "numberAbsoluteZero";
    public static final String NUMBER_ABSOLUTE_ONE = "numberAbsoluteOne";
    public static final String NUMBER_ABSOLUTE_MINUS_ONE = "numberAbsoluteMinusOne";
    public static final String NUMBER_PLUS_ONE = "numberPlusOne";
    public static final String NUMBER_MINUS_ONE = "numberMinusOne";
    public static final String NUMBER_MAX_TYPE = "numberMaxType";
    public static final String NUMBER_MIN_TYPE = "numberMinType";
    public static final String NUMBER_MAX_DOMAIN = "numberMaxDomain";
    public static final String NUMBER_MIN_DOMAIN = "numberMinDomain";
    public static final String NUMBER_MAX_DOMAIN_PLUS_ONE = "numberMaxDomainPlusOne";
    public static final String NUMBER_MAX_DOMAIN_MINUS_ONE = "numberMaxDomainMinusOne";
    public static final String NUMBER_MIN_DOMAIN_PLUS_ONE = "numberMinimumDomainPlusOne";
    public static final String NUMBER_MIN_DOMAIN_MINUS_ONE = "numberMinDomainMinusOne";

    public static final String STRING_NULL = "stringNull";
    public static final String STRING_EMPTY = "stringEmpty";
    public static final String STRING_PREDEFINED = "stringPredefined";
    public static final String STRING_NON_PRINTABLE = "stringNonPrintable";
    public static final String STRING_ADD_NON_PRINTABLE = "stringAddNonPrintable";
    public static final String STRING_ALPHANUMERIC = "stringAlphanumeric";
    public static final String STRING_OVERFLOW = "stringOverflow";

    public static final String LIST_NULL = "listNull";
    public static final String LIST_EMPTY = "listEmpty";
    public static final String LIST_REMOVE_ELEMENT = "listRemoveElement";
    public static final String LIST_ADD_ELEMENT = "listAddElement";
    public static final String LIST_DUPLICATE_ELEMENTS = "listDuplicateElements";
    public static final String LIST_REDUCE_TO_ONE = "listReduceToOne";

    private static final String[] numberFaults =
    { NUMBER_NULL, NUMBER_ABSOLUTE_ZERO, NUMBER_ABSOLUTE_ONE, NUMBER_ABSOLUTE_MINUS_ONE, NUMBER_PLUS_ONE,
	    NUMBER_MINUS_ONE, NUMBER_MAX_TYPE, NUMBER_MIN_TYPE, NUMBER_MAX_DOMAIN, NUMBER_MIN_DOMAIN,
	    NUMBER_MAX_DOMAIN_PLUS_ONE, NUMBER_MAX_DOMAIN_MINUS_ONE, NUMBER_MIN_DOMAIN_PLUS_ONE,
	    NUMBER_MIN_DOMAIN_MINUS_ONE };

    private static String[] stringFaults =
    { STRING_NULL, STRING_EMPTY, STRING_PREDEFINED, STRING_NON_PRINTABLE, STRING_ADD_NON_PRINTABLE,
	    STRING_ALPHANUMERIC, STRING_OVERFLOW };

    private static String[] listFaults =
    { LIST_NULL, LIST_EMPTY, LIST_REMOVE_ELEMENT, LIST_ADD_ELEMENT, LIST_DUPLICATE_ELEMENTS, LIST_REDUCE_TO_ONE };

    public static List<String> createFaultList(Object obj)
    {
	List<String> result;

	if (obj instanceof Long)
	{
	    result = new ArrayList<String>(Arrays.asList(numberFaults));
	}
	else if (obj instanceof String)
	{
	    result = new ArrayList<String>(Arrays.asList(stringFaults));
	}
	else if (obj instanceof List)
	{
	    result = new ArrayList<String>(Arrays.asList(listFaults));
	}
	else
	{
	    throw new RuntimeException("Unsupported Type:" + obj.getClass().getName());
	}

	return result;
    }
    
   
}