package pt.uc.dei.wsdbench.sut.injector.configuration;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.Properties;

import pt.uc.dei.wsdbench.sut.injector.core.domain.Domain;
import pt.uc.dei.wsdbench.sut.injector.core.domain.StringDomain;

public class Configuration
{
    public Properties properties = new Properties();

    public static final String dir = "C:\\dsn2009";

    public static final String fileExtension = "out";

    public Configuration()
    {

	try
	{
	    File file = new File("C:\\dsn2009\\domain.properties");
	    FileReader reader = new FileReader(file);
	    this.properties.load(reader);
	    reader.close();
	}
	catch (FileNotFoundException e)
	{
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	catch (IOException e)
	{
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}

	/*
	 * try { URL url =
	 * this.getClass().getClassLoader().getResource("domain.properties");
	 * 
	 * File file = new File(url.toURI()); FileReader reader = new
	 * FileReader(file); this.properties.load(reader); } catch
	 * (FileNotFoundException e) { e.printStackTrace(); } catch (IOException
	 * e) { // TODO Auto-generated catch block e.printStackTrace(); } catch
	 * (URISyntaxException e) { // TODO Auto-generated catch block
	 * e.printStackTrace(); }
	 */
    }

    public Domain buildDomain(String fullFieldName, Object parameter)
    {
	Domain result = new Domain();

	System.out.println("Trying to load domain for: " + fullFieldName);
	Long min = Long.valueOf(this.properties.getProperty(fullFieldName + ".min"));
	Long max = Long.valueOf(this.properties.getProperty(fullFieldName + ".max"));
	String pattern = this.properties.getProperty(fullFieldName + ".pattern");

	if (min == null || max == null)
	{
	    throw new RuntimeException("unable to find domain for: " + fullFieldName + "(min = " + min + " max = "
		    + max);
	}

	if (parameter instanceof String)
	{
	    result = new StringDomain();
	    if (pattern == null)
	    {
		throw new RuntimeException("Unable to find pattern for fullFieldName:" + fullFieldName);
	    }
	    ((StringDomain) result).setPattern(pattern);
	}

	result.setMaxSize(max);
	result.setMinSize(min);

	return result;
    }

}
