package pt.uc.dei.wsdbench.sut.injector.persistence;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.jboss.serial.io.JBossObjectInputStream;
import org.jboss.serial.io.JBossObjectOutputStream;

import pt.uc.dei.wsdbench.sut.injector.PersistenceException;
import pt.uc.dei.wsdbench.sut.injector.configuration.Configuration;

public class PersistenceManager<Type>
{
    private int savedItemCount = 0;

    String fileName = Configuration.dir + "\\robustness-tests";

    public List<Type> loadPendingResultList(String fileName, int count) throws PersistenceException
    {
	List<Type> result = new ArrayList<Type>();
	boolean done = false;

	try
	{
	    for (int i = 0; i < count; i++)
	    {
		FileInputStream fileStream = new FileInputStream(fileName + "-" + i + "." + Configuration.fileExtension);
		JBossObjectInputStream stream = new JBossObjectInputStream(fileStream);
		Type tmp = (Type) stream.readObjectUsingDataContainer();
		result.add(tmp);
	    }
	}
	catch (FileNotFoundException e)
	{
	    throw new PersistenceException(e);
	}
	catch (IOException e)
	{
	    throw new PersistenceException(e);
	}
	catch (ClassNotFoundException e)
	{
	    throw new PersistenceException(e);
	}

	if (result.size() == 0)
	{
	    System.out.println("Unable to load any PendingResult");
	}

	return result;
    }

    public void save(Type object) throws PersistenceException
    {
	try
	{
	    FileOutputStream fileStream = new FileOutputStream(fileName + "-" + savedItemCount + "."
		    + Configuration.fileExtension);
	    JBossObjectOutputStream stream = new JBossObjectOutputStream(fileStream);
	    stream.writeObjectUsingDataContainer(object);
	    stream.flush();
	    savedItemCount++;
	}
	catch (FileNotFoundException e)
	{
	    throw new PersistenceException(e);
	}
	catch (IOException e)
	{
	    throw new PersistenceException(e);
	}
    }
}
