/**
 * 
 */
package pt.uc.dei.wsdbench.sut.service.delegate.impl.pedro;

import java.sql.ResultSet;
import java.sql.SQLException;

/**
 * @author Pedro
 * 
 */
public interface DBHandler {
	/**
	 * Establish a connection to a Database with the params defined before
	 * 
	 * @return
	 * @throws SQLException
	 */
	public boolean connectDB() throws SQLException, ClassNotFoundException;

	/**
	 * 
	 * @return
	 * @throws SQLException
	 */
	public String closeDB() throws SQLException;

	/**
	 * 
	 * @param query
	 * @return
	 * @throws SQLException
	 */
	public ResultSet executeQuery(String query) throws SQLException;

	public ResultSet executeBulckQuery(String query, int nrows)
			throws SQLException;

	public int executeCmd(String cmd) throws SQLException;

	public ResultSet executeBulckCmd(String cmd, int nrows) throws SQLException;

	public boolean commit() throws SQLException;

	public boolean rollback() throws SQLException;

	public void setAutoCommit(boolean value) throws SQLException;

	public boolean getAutoCommit() throws SQLException;

	public String getPasswd();

	public void setPasswd(String passwd);

	public int getPort();

	public void setPort(int port);

	public String getServer();

	public void setServer(String server);

	public String getSid();

	public void setSid(String sid);

	public String getUrl();

	public String getUserName();

	public void setUserName(String userName);

}
