package pt.uc.dei.wsdbench.sut.service.delegate.impl.pedro;

import java.sql.ResultSet;
import java.sql.SQLException;

import pt.uc.dei.wsdbench.generic.component.tpcapp.Lcg64RngTools;
import pt.uc.dei.wsdbench.sut.external.LongWrapper;
import pt.uc.dei.wsdbench.sut.external.Pov;
import pt.uc.dei.wsdbench.sut.service.delegate.INewCustomerServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.NewCustomerInput;
import pt.uc.dei.wsdbench.sut.service.output.NewCustomerOutput;

public class NewCustomerServiceDelegate implements INewCustomerServiceDelegate {

    private String server = "10.3.3.191";
    private int port = 1521;
    private String sid = "orcl";
    private String userName = "wsdbench";
    private String passwd = "samsung";
    Database db = null;

    public NewCustomerOutput process(NewCustomerInput input)
            throws SQLException {
        db = new Database(server, port, sid, userName, passwd);
        NewCustomerOutput nco = new NewCustomerOutput();
        String pm = input.getPaymentMethod();
        if (pm != null) {
            // if (pm.equalsIgnoreCase("PO"))
            if (true) {
                // initiates a web service request to the POV to validate the
                // CREDIT_INFO
                Pov pov = new Pov();
                LongWrapper wrapper = pov.call("" + input.getPoId(), input.getBusinessName());
                wrapper.getValue().getClass();
                /*
                 * if (POV == false) return(SOAP fault to the EB). else auth_id=
                 * POV;
                 */

                try {
                    if (db.connectDB()) {
                        // System.out.println("Connection to DB Established");
						/* dbms transaction */
                        long addr_id_temp = getAddressID(input);
                        if (addr_id_temp == -1) {
                            // cria um novo registo de morada na tabela ADDRESS
                            addr_id_temp = createAddress(input);
                            if (addr_id_temp == -1) {
                                db.closeDB();
                                throw new RuntimeException(
                                        "DB Error: Couldn't create Address ID");
                            }
                        }

                        long c_id = insertCostumer(input, addr_id_temp);
                        if (c_id != -1) {
                            nco.setCustomerId(c_id);
                        // nco.setSystemIdentifier("");
                        } else {
                            db.closeDB();
                            throw new RuntimeException(
                                    "DB Error: Couldn't insert Costumer");
                        }
                    }
                    db.closeDB();
                } catch (SQLException e) {
                    db.closeDB();
                    // e.printStackTrace();
                    throw e;
                // throw new RuntimeException(
                // "DB Error (ClassNotFoundException): Couldn't Establish Connection");
                }
            }
        }
        // return(SYSTEM_IDENTIFIER, C_ID);
        // System.out.println("2222222222222222222222222");
        // System.out.println("SI: "+nco.getSystemIdentifier());
        // System.out.println("CID: "+nco.getCustomerId());
        return nco;
    }

    private synchronized long getAddressID(NewCustomerInput input)
            throws SQLException {
        long addId = -1;
        long addr_co_id = getCOID(input);
        // System.out.println("\naddr_co_id: "+addr_co_id);
        if (addr_co_id != -1) {
            String ba1 = input.getBillingAddr1();
            String ba2 = input.getBillingAddr2();
            String bc = input.getBillingCity();
            String bs = input.getBillingState();
            String bz = input.getBillingZip();
            String sql = null;
            if ((ba1 != null) && (ba2 != null) && (bc != null) && (bs != null) && (bz != null)) {
                String CR = System.getProperty("line.separator");
                sql = "select addr_id from address" + " where lower(ADDR_STREET1) = '" + ba1.toLowerCase().trim() + "'" + " and lower(ADDR_STREET2) = '" + ba2.toLowerCase().trim() + "'" + " and lower(ADDR_CITY) = '" + bc.toLowerCase().trim() + "'" + " and lower(ADDR_STATE) = '" + bs.toLowerCase().trim() + "'" + " and lower(ADDR_ZIP) = '" + bz.toLowerCase().trim() + "'" + " and ADDR_CO_ID = " + addr_co_id;
            }
            // System.out.println("\n"+sql);

            ResultSet rs = db.executeQuery(sql);
            boolean v = rs.next();
            // System.out.println("\nRS.NEXT: "+v);
            if (v) {
                addId = rs.getLong(1);
            }
            if (rs != null) {
                rs.close();
            }
            System.out.println("\nADDID: " + addId);

        // catch(ClassNotFoundException e){e.printStackTrace();return(0);}
        }

        return (addId);
    }

    private synchronized long createAddress(NewCustomerInput input)
            throws SQLException {
        long addr_id = -1;
        String sql = "";

        long addr_co_id = getCOID(input);
        System.out.println("****************************************************: " + addr_co_id);

        if (addr_co_id != -1) {
            sql = "select max(addr_id) from address";
            ResultSet rs = db.executeQuery(sql);
            if (rs.next()) {
                addr_id = rs.getLong(1);
            // System.out.println("\naddr_id: "+addr_id);
            }
            addr_id++;

            sql = "INSERT INTO ADDRESS(" + " ADDR_ID," + " ADDR_STREET1," + " ADDR_STREET2," + " ADDR_CITY," + " ADDR_STATE," + " ADDR_ZIP," + " ADDR_CO_ID)" + " VALUES" + "( " + addr_id + ", '" + input.getBillingAddr1() + "'" + ", '" + input.getBillingAddr2() + "'" + ", '" + input.getBillingCity() + "'" + ", '" + input.getBillingState() + "'" + ", '" + input.getBillingZip() + "'" + ", " + addr_co_id + ")";

            // System.out.println("\n"+sql);
            int rc = db.executeCmd(sql);
            if (rs != null) {
                rs.close();
            }
        }

        return (addr_id);
    }

    private long getCOID(NewCustomerInput input) throws SQLException {
        String sql = "select co_id from country where lower(co_name) = lower('" + input.getBillingCountry() + "')";
        long res = -1;

        ResultSet rs = db.executeQuery(sql);
        if (rs.next()) {
            res = rs.getLong(1);
        }
        if (rs != null) {
            rs.close();
        }

        return (res);
    }

    private synchronized long insertCostumer(NewCustomerInput input,
            long addr_id_temp) throws SQLException {
        System.out.println("INSERT COSTUMER!!!!!!");
        long c_id = -1;
        Lcg64RngTools tools = new Lcg64RngTools(System.currentTimeMillis());
        int discount = tools.Next(0, 50);
        String sql = "";

        sql = "SELECT max(C_ID) FROM customer";
        ResultSet rs = db.executeQuery(sql);
        if (rs.next()) {
            c_id = rs.getLong(1);
        }

        c_id++;
        sql = "INSERT INTO CUSTOMER(" + " C_ID," + " C_BUSINESS_NAME," + " C_BUSINESS_INFO," + " C_PASSWD," + " C_CONTACT_FNAME," + " C_CONTACT_LNAME," + " C_CONTACT_PHONE," + " C_CONTACT_EMAIL," + " C_PAYMENT_METHOD," + " C_CREDIT_INFO," + " C_DISCOUNT," + " C_ADDR_ID," + " C_PO)" + " VALUES" + "( " + c_id + ", '" + input.getBusinessName() + "'" + ", '" + input.getBusinessInfo() + "'" + ", '" + input.getPassword() + "'" + ", '" + input.getContactFName() + "'" + ", '" + input.getContactLName() + "'" + ", '" + input.getContactPhone() + "'" + ", '" + input.getContactEmail() + "'" + ", '" + input.getPaymentMethod() + "'" + ", '" + input.getCreditInfo() + "'" + ", " + discount + ", " + addr_id_temp + ", " + input.getPoId() + ")";
        int rc = db.executeCmd(sql);
        if (rs != null) {
            rs.close();
        }

        return (c_id);
    }
}
