package pt.uc.dei.wsdbench.sut.service.delegate.impl.pedro;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.text.Format;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.TimeZone;

import pt.uc.dei.wsdbench.sut.service.delegate.INewProductsServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.NewProductsInput;
import pt.uc.dei.wsdbench.sut.service.output.NewProduct;
import pt.uc.dei.wsdbench.sut.service.output.NewProductsOutput;

public class NewProductsServiceDelegate implements INewProductsServiceDelegate {
	private String server = "10.3.3.191";
	private int port = 1521;
	private String sid = "orcl";
	private String userName = "wsdbench";
	private String passwd = "samsung";
	Database db = null;

	public NewProductsOutput process(NewProductsInput input)
			throws SQLException {
		db = new Database(server, port, sid, userName, passwd);
		NewProductsOutput npo = new NewProductsOutput();
		try {
			if (db.connectDB()) {
				npo = getData(npo, input);
				db.closeDB();
			}
		} catch (SQLException e) {
			db.closeDB();
			throw e;
		}

		return npo;
	}

	private synchronized NewProductsOutput getData(NewProductsOutput npo,
			NewProductsInput input) throws SQLException {
		// setfetch size item_limit
		Long il = input.getItemLimit();
		Long l = null;
		if (il != null) {
			l = new Long(il);
			db.setFetchSize(l.intValue());
		}
		List<NewProduct> npl = new ArrayList<NewProduct>();

		// Date currDate= System.getCurrDate
		Calendar cal = Calendar.getInstance(TimeZone.getDefault());

		Long cod = input.getCutOffDuration();
		long time = 0;
		if (cod != null)
			time = cal.getTimeInMillis() - cod.longValue();
		else
			time = cal.getTimeInMillis();
		Date date = new Date(time);
		Format formatter = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		String s = formatter.format(date);
		// System.out.println("\ncutoffdur: "+input.getCutOffDuration());
		// System.out.println("\ncalmili: "+cal.getTimeInMillis());
		String sql = "select i_id, i_title, a_fname, a_lname"
				+ " from item, author" + " where lower(i_subject) = lower('"
				+ input.getSubjectString() + "')"
				+ " and i_pub_date > to_timestamp('" + s
				+ "', 'YYYY-MM-DD HH24:MI:SS')" + " and i_a_id = a_id"
				+ " order by i_pub_date desc, i_title asc";

		// System.out.println("\n"+sql);
		// try
		// {
		ResultSet rs = db.executeQuery(sql);
		while (rs.next()) {
			long i_id = rs.getLong(1);
			String i_title = rs.getString(2);
			String a_fname = rs.getString(3);
			String a_lname = rs.getString(4);
			NewProduct np = new NewProduct();
			np.setItemId(i_id);
			np.setItemTitle(i_title);
			np.setAuthorLName(a_lname);
			np.setAuthorFName(a_fname);
			npl.add(np);
			/*
			 * System.out.println("\ni_id: "+i_id);
			 * System.out.println("\ni_title: "+i_title);
			 * System.out.println("\na_lname: "+a_lname);
			 * System.out.println("\na_fname: "+a_fname);
			 */
		}
		if (rs != null)
			rs.close();
		npo.setNewProductsList(npl);

		db.closeDB();
		return (npo);
	}

}
