package pt.uc.dei.wsdbench.sut.service.delegate.impl.pedro;

import java.sql.Date;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

import pt.uc.dei.wsdbench.sut.service.delegate.IProductDetailServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.ProductDetailInput;
import pt.uc.dei.wsdbench.sut.service.output.ProductDetailOutput;
import pt.uc.dei.wsdbench.sut.service.output.ProductDetailPojo;

public class ProductDetailServiceDelegate implements
        IProductDetailServiceDelegate {

    private String server = "10.3.3.191";
    private int port = 1521;
    private String sid = "orcl";
    private String userName = "wsdbench";
    private String passwd = "samsung";
    Database db = null;

    public ProductDetailOutput process(ProductDetailInput input)
            throws SQLException {

        db = new Database(server, port, sid, userName, passwd);
        ProductDetailOutput pdo = new ProductDetailOutput();
        try {
            if (db.connectDB()) {
                pdo = getData(input);
                db.closeDB();
            } else {
                System.out.println("!!!!!!!!!!!!!!!!!!!db.connectDB()");
            }
        } catch (SQLException e) {
            db.closeDB();
            throw e;
        }
        if (pdo != null) {
            System.out.println("********# PDO: " + pdo.getDetailedProductsList());
        }

        return pdo;
    }

    private ProductDetailOutput getData(ProductDetailInput input)
            throws SQLException {
        List<Long> list = input.getItemIds();
        ProductDetailOutput pdo = new ProductDetailOutput();
        String sql = "Select i_id, i_title, a_fname, a_lname, i_pub_date, i_publisher, " + " i_subject, i_desc, i_cost, i_srp, i_avail, i_isbn," + " i_page, i_dimensions, i_image" + " from item, author" + " where a_id = i_a_id" + " and i_id = ";

        if (list != null) {
            // try
            // {
            int tam = list.size();
            List<ProductDetailPojo> dpl = new ArrayList<ProductDetailPojo>();
            for (int i = 0; i < tam; ++i) {
                Long l = list.get(i);
                // System.out.println("\n"+sql+l);
                // ResultSet rs= db.executeQuery(sql, list);
                ResultSet rs = db.executeQuery(sql + l);

                while (rs.next()) {
                    long i_id = rs.getLong("i_id");
                    String i_title = rs.getString("i_title");
                    String a_fname = rs.getString("a_fname");
                    String a_lname = rs.getString("a_lname");
                    Date i_pub_date = rs.getDate("i_pub_date");
                    String i_publisher = rs.getString("i_publisher");
                    String i_subject = rs.getString("i_subject");
                    String i_desc = rs.getString("i_desc");
                    String i_cost = rs.getString("i_cost");
                    String i_srp = rs.getString("i_srp");
                    Date i_avail = rs.getDate("i_avail");
                    String i_isbn = rs.getString("i_isbn");
                    String i_page = rs.getString("i_page");
                    String i_dimensions = rs.getString("i_dimensions");
                    String i_image = rs.getString("i_image");

                    /*
                     * System.out.println("\ni_id: "+i_id);
                     * System.out.println("\ni_title: "+i_title);
                     * System.out.println("\na_fname: "+a_fname);
                     * System.out.println("\na_lname: "+a_lname);
                     * System.out.println("\ni_pub_date: "+i_pub_date);
                     * System.out.println("\ni_publisher: "+i_publisher);
                     * System.out.println("\ni_subject: "+i_subject);
                     * System.out.println("\ni_desc: "+i_desc);
                     * System.out.println("\ni_cost: "+i_cost);
                     * System.out.println("\ni_srp: "+i_srp);
                     * System.out.println("\ni_avail: "+i_avail);
                     * System.out.println("\ni_isbn: "+i_isbn);
                     * System.out.println("\ni_page: "+i_page);
                     * System.out.println("\ni_dimensions: "+i_dimensions);
                     * System.out.println("\ni_image: "+i_image);
                     */
                    ProductDetailPojo pdp = new ProductDetailPojo();
                    pdp.setItemId(i_id);
                    pdp.setItemTitle(i_title);
                    pdp.setAuthorFName(a_fname);
                    pdp.setAuthorLName(a_lname);
                    pdp.setItemPubDate(i_pub_date);
                    pdp.setItemPublisher(i_publisher);
                    pdp.setItemSubject(i_subject);
                    pdp.setItemDesc(i_desc);
                    pdp.setItemCost(i_cost);
                    pdp.setItemSrp(i_srp);
                    pdp.setItemAvail(i_avail.toString());
                    pdp.setItemIsbn(i_isbn);
                    pdp.setItemPage(i_page);
                    pdp.setItemDimensions(i_dimensions);
                    pdp.setImageBytes(i_image.getBytes());

                    dpl.add(pdp);
                }
                if (rs != null) {
                    rs.close();
                }
            }
            pdo.setDetailedProductsList(dpl);
        // }
        // catch (SQLException e)
        // {
        // // TODO Auto-generated catch block
        // e.printStackTrace();
        // }
        } else {
            System.out.println("Source List is null!!!");
        }
        /*
         * percorrer o result set criar uma lista com os dados do resultset
         */
        return (pdo);
    }
}
