package pt.uc.dei.wsdbench.sut.service.delegate.impl.tpcapp;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.sut.configuration.Configurator;
import pt.uc.dei.wsdbench.sut.dao.tpcapp.ChangePaymentMethodDao;
import pt.uc.dei.wsdbench.sut.exception.SutException;
import pt.uc.dei.wsdbench.sut.external.LongWrapper;
import pt.uc.dei.wsdbench.sut.external.Pov;
import pt.uc.dei.wsdbench.sut.service.delegate.IChangePaymentMethodServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.ChangePaymentMethodInput;
import pt.uc.dei.wsdbench.sut.service.output.ChangePaymentMethodOutput;
import pt.uc.dei.wsdbench.sut.service.validator.ChangePaymentMethodServiceValidator;

public class ChangePaymentMethodServiceDelegate implements
        IChangePaymentMethodServiceDelegate {

    public Log log = LogFactory.getLog(ChangePaymentMethodServiceDelegate.class);
    private ChangePaymentMethodDao changePaymentMethodDao;
    private ChangePaymentMethodServiceValidator changePaymentMethodServiceValidator;
    private Pov pov;
    private Configurator configurator;

    public ChangePaymentMethodServiceDelegate() {
    }

    public ChangePaymentMethodOutput process(
            final ChangePaymentMethodInput input) throws Exception {
        ChangePaymentMethodOutput result = new ChangePaymentMethodOutput();

        if (this.configurator.isUseValidation()) {
            try {
                this.changePaymentMethodServiceValidator.validate(input);
            } catch (ValidatorException e) {
                throw new SutException(e);
            }
        }

        if (input.getPaymentMethod().equals("PO")) {

            String bName = changePaymentMethodDao.findBusinessNameById(input.getCustomerId());
            LongWrapper wrapper = this.pov.call(input.getPoId(), bName);
            wrapper.getValue().getClass();

        }

        this.changePaymentMethodDao.update(input);

        result.setCurrPaymentMethod(input.getPaymentMethod());

        return result;
    }

    public void setChangePaymentMethodDao(
            ChangePaymentMethodDao changePaymentMethodDao) {
        this.changePaymentMethodDao = changePaymentMethodDao;
    }

    public void setPov(Pov pov) {
        this.pov = pov;
    }

    public void setChangePaymentMethodServiceValidator(
            ChangePaymentMethodServiceValidator changePaymentMethodServiceValidator) {
        this.changePaymentMethodServiceValidator = changePaymentMethodServiceValidator;
    }

    public void setConfigurator(Configurator configurator) {
        this.configurator = configurator;
    }
}
