package pt.uc.dei.wsdbench.sut.service.delegate.impl.tpcapp;

import java.util.List;

import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.sut.configuration.Configurator;
import pt.uc.dei.wsdbench.sut.dao.tpcapp.NewProductsDao;
import pt.uc.dei.wsdbench.sut.exception.SutException;
import pt.uc.dei.wsdbench.sut.service.delegate.INewProductsServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.NewProductsInput;
import pt.uc.dei.wsdbench.sut.service.output.NewProduct;
import pt.uc.dei.wsdbench.sut.service.output.NewProductsOutput;
import pt.uc.dei.wsdbench.sut.service.validator.NewProductsServiceValidator;

public class NewProductsServiceDelegate implements INewProductsServiceDelegate
{

    private NewProductsDao newProductsDao;

    private Configurator configurator;

    private NewProductsServiceValidator newProductsServiceValidator;

    public void setNewProductsServiceValidator(NewProductsServiceValidator newProductsServiceValidator)
    {
	this.newProductsServiceValidator = newProductsServiceValidator;
    }

    public NewProductsOutput process(NewProductsInput input) throws Exception
    {
	NewProductsOutput result = new NewProductsOutput();
	List<NewProduct> newProductsList;

	if (this.configurator.isUseValidation())
	{
	    try
	    {
		this.newProductsServiceValidator.validate(input);
	    }
	    catch (ValidatorException e)
	    {
		throw new SutException(e);
	    }
	}

	newProductsList = this.newProductsDao.findNewProducts(input);

	result.setNewProductsList(newProductsList);

	return result;
    }

    public void setNewProductsDao(NewProductsDao newProductsDao)
    {
	this.newProductsDao = newProductsDao;
    }

    public void setConfigurator(Configurator configurator)
    {
	this.configurator = configurator;
    }

}
