package pt.uc.dei.wsdbench.sut.service.delegate.impl.tpcapp;

import java.util.List;

import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.sut.configuration.Configurator;
import pt.uc.dei.wsdbench.sut.dao.tpcapp.ProductDetailDao;
import pt.uc.dei.wsdbench.sut.service.delegate.IProductDetailServiceDelegate;
import pt.uc.dei.wsdbench.sut.service.input.ProductDetailInput;
import pt.uc.dei.wsdbench.sut.service.output.ProductDetailOutput;
import pt.uc.dei.wsdbench.sut.service.output.ProductDetailPojo;
import pt.uc.dei.wsdbench.sut.service.validator.ProductDetailServiceValidator;

public class ProductDetailServiceDelegate implements IProductDetailServiceDelegate
{

    private ProductDetailDao productDetailDao;

    private Configurator configurator;

    private ProductDetailServiceValidator productDetailServiceValidator;

    public void setConfigurator(Configurator configurator)
    {
	this.configurator = configurator;
    }

    public ProductDetailOutput process(ProductDetailInput input) throws Exception
    {
	ProductDetailOutput result = new ProductDetailOutput();

	if (this.configurator.isUseValidation())
	{
	    try
	    {
		this.productDetailServiceValidator.validate(input);
	    }
	    catch (ValidatorException e)
	    {
		throw e;
	    }
	}

	List<ProductDetailPojo> detailedProductsList = this.productDetailDao.findItemsById(input.getItemIds());
	result.setDetailedProductsList(detailedProductsList);

	return result;
    }

    public void setProductDetailDao(ProductDetailDao productDetailDao)
    {
	this.productDetailDao = productDetailDao;
    }

    public void setProductDetailServiceValidator(ProductDetailServiceValidator productDetailServiceValidator)
    {
	this.productDetailServiceValidator = productDetailServiceValidator;
    }
}
