package pt.uc.dei.wsdbench.sut.service.validator;

import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.sut.service.input.NewCustomerInput;

public class NewCustomerServiceValidator
{
    GenericValidator genericValidator;

    public void validate(NewCustomerInput input) throws ValidatorException
    {
	genericValidator.validateFields(input);

	genericValidator.validateAString(15, 20, "businessName", input.getBusinessName());
	genericValidator.validateAString(40, 100, "businessInfo", input.getBusinessInfo());
	genericValidator.validatePassword(input);
	genericValidator.validateAString(8, 15, "contactFName", input.getContactFName());
	genericValidator.validateAString(8, 15, "contactLName", input.getContactLName());
	genericValidator.validateNString(9, 16, "contactPhone", input.getContactPhone());
	genericValidator.validateEmailFormat(input);
	genericValidator.validatePaymentMethod(input.getPaymentMethod());
	genericValidator.validateNumber(1, 1000000, "poId", input.getPoId());
	genericValidator.validateAString(40, 300, "creditInfo", input.getCreditInfo());
	genericValidator.validateAString(15, 40, "billingAddr1", input.getBillingAddr1());
	genericValidator.validateAString(15, 40, "billingAddr2", input.getBillingAddr2());
	genericValidator.validateAString(4, 30, "billingCity", input.getBillingCity());
	genericValidator.validateAString(2, 20, "billingState", input.getBillingState());
	genericValidator.validateAString(5, 10, "billingZip", input.getBillingZip());
	genericValidator.validateCountry(input.getBillingCountry());
    }

    public void setGenericValidator(GenericValidator genericValidator)
    {
	this.genericValidator = genericValidator;
    }

}
