package pt.uc.dei.wsdbench.sut.service.validator;

import java.util.Arrays;
import java.util.List;

import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.generic.component.tpcapp.Constants;
import pt.uc.dei.wsdbench.sut.configuration.Configurator;
import pt.uc.dei.wsdbench.sut.service.input.NewProductsInput;

public class NewProductsServiceValidator {
	private GenericValidator genericValidator;

	private Configurator configurator;

	public void setConfigurator(Configurator configurator) {
		this.configurator = configurator;
	}

	public void setGenericValidator(GenericValidator genericValidator) {
		this.genericValidator = genericValidator;
	}

	public void validate(NewProductsInput input) throws ValidatorException {
		genericValidator.validateFields(input);

		this.genericValidator.validateNumber(1, 10, "cutOffDuration", input
				.getCutOffDuration());
		final List<String> subjects = Arrays.asList(Constants.SUBJECT_LIST);

		if (!subjects.contains(input.getSubjectString())) {
			throw new ValidatorException("Subject (" + input.getSubjectString()
					+ ") not found in subject list: " + Constants.SUBJECT_LIST);
		}

		this.genericValidator.validateNumber(1, new Long(this.configurator
				.getItemCount()), "itemLimit", input.getItemLimit());
	}
}
