package pt.uc.dei.wsdbench.sut.service.validator;

import org.apache.commons.validator.ValidatorException;

import pt.uc.dei.wsdbench.generic.component.tpcapp.Constants;
import pt.uc.dei.wsdbench.sut.service.input.ProductDetailInput;

public class ProductDetailServiceValidator {
	private GenericValidator genericValidator;

	public void validate(ProductDetailInput input) throws ValidatorException {
		genericValidator.validateFields(input);

		if (input.getItemIds() == null) {
			throw new ValidatorException(
					"Product detail ids list is currently null");
		} else if (input.getItemIds().size() > Constants.MAX_PRODUCT_DETAIL_IDS
				|| input.getItemIds().size() == 0) {
			throw new ValidatorException(
					"Product detail ids list size invalid. Asked for "
							+ input.getItemIds().size()
							+ " items. (Maximum is "
							+ Constants.MAX_PRODUCT_DETAIL_IDS + ")");
		}
	}

	public void setGenericValidator(GenericValidator genericValidator) {
		this.genericValidator = genericValidator;
	}

}
