/**
 *
 */
package pt.uc.dei.wsst.services;

import java.io.FileOutputStream;
import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.sql.Statement;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.jdom.output.XMLOutputter;

/**
 * @author  $Author: nmsa $
 */
public final class Util {

    public static final String DRIVER = "sun.jdbc.odbc.JdbcOdbcDriver";
    public static final String URL = "jdbc:odbc:";

    public static Connection getOdbcConnection(String odbcname)
            throws SQLException {
        try {
            Class.forName(DRIVER);
        } catch (ClassNotFoundException ex) {
        }
        Connection connection = DriverManager.getConnection(URL + odbcname);
        return connection;
    }

    public static void close(Connection con) {
        try {
            con.close();
        } catch (SQLException ex) {
        }
    }

    //
    // JamesSmith Code...
    //
    //
    public static final String XP_DATA_DOCUMENT = "C:\\nmsa\\servicesdata\\xpdata.xml";
//    public static final String XP_DATA_DOCUMENT = "C:\\srds2009\\tpcapp\\servicesdata\\xpdata.xml";
    public static final String JS_dumpTarget = "C:\\nmsa\\servicesdata\\xpdata" + System.currentTimeMillis() + ".xml";
//    public static final String JS_dumpTarget = "C:\\srds2009\\tpcapp\\servicesdata\\xpdata" + System.currentTimeMillis() + ".xml";

    public static Document loadXmlDocument() {
        SAXBuilder sb = new SAXBuilder();
        try {
            return sb.build(XP_DATA_DOCUMENT);
        } catch (JDOMException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
        return null;
    }

    public static void getXmlDocument() {
        Element root = new Element("xpdata", "xp", "http://xp.services.wsst.dei.uc.pt/data");
        root.addContent(getJSDB());
        root.addContent(getBank3());
        try {

            Document doc = new Document(root);
            XMLOutputter xo = new XMLOutputter(org.jdom.output.Format.getPrettyFormat());
            xo.output(doc, new FileOutputStream(JS_dumpTarget));
            System.out.println("File written: " + JS_dumpTarget);
        } catch (Exception ex) {
            System.out.println("Cannot write...");
            ex.printStackTrace();
        }
    }

    private static Element getBank3() {
        Element bank3 = new Element("bank3db", "b3", "http://bank3.services.wsst.dei.uc.pt/data.xml");
        try {
            Connection c = getOdbcConnection("BankDatabase");
            Statement s = c.createStatement();
            boolean execute = s.execute("SELECT * FROM CustomerInfo;");
            Element customerInfo = new Element("CustomerInfo");
            bank3.addContent(customerInfo);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element customer = new Element("Customer");
                    customer.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    customer.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        customer.addContent(el);
                    }
                    customerInfo.addContent(customer);
                }
            }
            execute = s.execute("SELECT * FROM BalanceInfo;");
            Element BalanceInfo = new Element("BalanceInfo");
            bank3.addContent(BalanceInfo);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element balance = new Element("Balance");
                    balance.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    balance.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        balance.addContent(el);
                    }
                    BalanceInfo.addContent(balance);
                }
            }
            execute = s.execute("SELECT * FROM DepositInfo;");
            Element depositInfo = new Element("DepositInfo");
            bank3.addContent(depositInfo);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element deposit = new Element("Deposit");
                    deposit.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    deposit.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        deposit.addContent(el);
                    }
                    depositInfo.addContent(deposit);
                }
            }
            execute = s.execute("SELECT * FROM WithdrawInfo;");
            Element withdrawInfo = new Element("WithdrawInfo");
            bank3.addContent(withdrawInfo);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element withdraw = new Element("Withdraw");
                    withdraw.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    withdraw.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        withdraw.addContent(el);
                    }
                    withdrawInfo.addContent(withdraw);
                }
            }

            s.close();
        } catch (SQLException se) {
            se.printStackTrace();
        }
        return bank3;
    }

    private static Element getJSDB() {
        Element jsdb = new Element("jamessmithmdb", "js", "http://www.geocities.com/james_smith73/james.zip");
        try {
            Connection c = getOdbcConnection("james");
            Statement s = c.createStatement();
            boolean execute = s.execute("SELECT * FROM login;");
            Element loginTable = new Element("loginTable");
            jsdb.addContent(loginTable);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element login = new Element("login");
                    login.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    login.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        login.addContent(el);
                    }
                    loginTable.addContent(login);
                }
            }
            s.close();
            s = c.createStatement();
            execute = s.execute("SELECT * FROM student_det;");
            Element studentTable = new Element("studentTable");
            jsdb.addContent(studentTable);
            if (execute) {
                ResultSet rs = s.getResultSet();
                ResultSetMetaData rmeta = rs.getMetaData();
                int numColumns = rmeta.getColumnCount();
                while (rs.next()) {
                    Element student = new Element("student");
                    student.setAttribute(rmeta.getColumnName(1), rs.getString(rmeta.getColumnName(1)));
                    student.setAttribute(rmeta.getColumnName(2), rs.getString(rmeta.getColumnName(2)));
                    for (int i = 3; i <= numColumns; ++i) {
                        String cname = rmeta.getColumnName(i);
                        Element el = new Element(cname);
                        el.addContent(rs.getString(cname));
                        student.addContent(el);
                    }
                    studentTable.addContent(student);
                }
            }
        } catch (SQLException se) {
            se.printStackTrace();
        }
        return jsdb;
    }

    private Util() {
    }
}
