/*******************************************************************************
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 ******************************************************************************/
package pt.uc.dei.wsst.services.xp;

import java.util.List;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import org.jdom.Attribute;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.xpath.XPath;
import pt.uc.dei.wsst.services.bank3.Bank3;
import pt.uc.dei.wsst.services.jamessmith.JamesSmith;
import static pt.uc.dei.wsst.services.Util.loadXmlDocument;

/**
 *
 * @author Nuno Antunes
 */
@WebService
public class XOperations {

    private final Document xml;

    public XOperations() {
        xml = loadXmlDocument();
    }

    /**
     * @see JamesSmith#login(java.lang.String, java.lang.String)
     * @param login
     * @param pass
     * @return
     */
    @WebMethod(operationName = "login")
    public String login(
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "login") String login,
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "pass") String pass) {
        String ret = null;
        try {
            String path = "//login[@username='" + login + "' and @password='" + pass + "']";
            Element node = (Element) XPath.selectSingleNode(xml, path);
            if (node != null) {
                ret = node.getChildText("Designation");
            } else {
                ret = "Please Re-Login";
            }
        } catch (Exception ex) {
//            System.out.println("Exception catched: " + ex); // Ignored by the programmer
        }
        return ret;
    }

    /**
     *
     * @see Bank3#displayInfo(java.lang.String, int)
     * @param accNum
     * @param i {1,2}
     */
    @WebMethod(operationName = "displayInfo")
    public String[] displayInfo(
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "accNum") String accNum,
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "i") int i) {
        String[] ret = null;
        String path = null;
        try {
            if (i == 1) {
                path = "//CustomerInfo/Customer[@Account_Num='" + accNum + "']";
            } else if (i == 2) {
                path = "//BalanceInfo/Balance[@Account_Num='" + accNum + "']";
            }
            @SuppressWarnings("unchecked")
            List<Element> nodes = (List<Element>) XPath.selectNodes(xml, path);
            if (i == 1) {
                //use node instead Result
                for (Element node : nodes) {
                    ret = new String[]{node.getAttributeValue("Name"), node.getAttributeValue("Account_Num"), node.getChildText("Date"), node.getChildText("Address"), node.getChildText("Age")};
                }
            } else if (i == 2) {
                for (Element node : nodes) {
                    ret = new String[]{node.getAttributeValue("Name"), node.getAttributeValue("Account_Num"), node.getChildText("Balance")};
                }
            }
        } catch (JDOMException jde) {
//            System.out.println("HI" + squl);// stdout is considered ignored as the application provides a GUI to the user
        }
        return ret;//
    }

    /**
     * @see Bank3#displayDeposit(java.lang.String, int)
     * @param accNum
     * @param i {1,2}
     */
    @WebMethod(operationName = "displayDeposit")
    @SuppressWarnings("unchecked")
    public String displayDeposit(
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "accNum") String accNum,
            @WebParam(targetNamespace = "http://xp.services.wsst.dei.uc.pt/", name = "i") int i) {
        StringBuilder sb = new StringBuilder();

        try {
            List<Element> nodes = null;
            if (i == 1) {
                nodes = (List<Element>) XPath.selectNodes(xml, "//DepositInfo/Deposit[@Account_Num='" + accNum + "']");
            } else if (i == 2) {
                nodes = (List<Element>) XPath.selectNodes(xml, "//WithdrawInfo/Withdraw[@Account_Num='" + accNum + "']");
            }
            if (nodes != null) {
                for (Element node : nodes) {
                    for (Object object : node.getAttributes()) {
                        sb.append(((Attribute) object).getValue()).append(" \t ");
                    }
                    for (Object object : node.getChildren()) {
                        sb.append(((Element) object).getText()).append(" \t ");
                    }
                    sb.append("\n");
                }
            }
        } catch (JDOMException jdome) {
            sb.append(jdome);
            System.out.println("jdome: " + jdome);
        }
        return sb.toString();
    }
}
